local menuitems = {"Hat", "Hat Color", "Death Sound", "Hit Sound", "Chat Sound"}
local menubuttons = {}
menubuttons["none"] = {
	btn = 0,
	name = "\128Console: \139cosmetics"
}
menubuttons["firenormal"] = {
	btn = BT_FIRENORMAL,
	name = "Fire Normal"
}
menubuttons["tossflag"] = {
	btn = BT_TOSSFLAG,
	name = "Toss Flag"
}
menubuttons["custom1"] = {
	btn = BT_CUSTOM1,
	name = "Custom 1"
}
menubuttons["custom2"] = {
	btn = BT_CUSTOM2,
	name = "Custom 2"
}
menubuttons["custom3"] = {
	btn = BT_CUSTOM3,
	name = "Custom 3"
}
menubuttons["nextweapon"] = {
	btn = BT_WEAPONNEXT,
	name = "Next Weapon"
}
menubuttons["prevweapon"] = {
	btn = BT_WEAPONPREV,
	name = "Prev Weapon"
}
local costime = 0
local slide = 0
local slidevert = 0

--Save to the data file
/*local function save(player)
	if player != consoleplayer return end
	
	local file = io.openlocal("client/cosmetics.cfg", "w")
	
	if player.cos_hat
		file:write("hat \""+Cosmetics.Hats[player.cos_hat].name+"\"\n")
	end
	if player.cos_hatcolor
		file:write("wait 1\n")
		file:write("hatcolor \""+skincolors[player.cos_hatcolor].name+"\"\n")
	end
	if player.cos_deathsound
		file:write("wait 1\n")
		file:write("deathsound \""+Cosmetics.Deathsounds[player.cos_deathsound].name+"\"\n")
	end
	if player.cos_hitsound
		file:write("wait 1\n")
		file:write("hitsound \""+Cosmetics.Hitsounds[player.cos_hitsound].name+"\"\n")
	end
	if player.cos_chatsound
		file:write("wait 1\n")
		file:write("chatsound \""+Cosmetics.Chatsounds[player.cos_chatsound].name+"\"\n")
	end
	if player.cos_button
		file:write("wait 1\n")
		file:write("cos_button \""+player.cos_button+"\"\n")
	end
	file:write("wait 1\n")
	file:write("echo \"Cosmetics config loaded!\"\n")
	file:write("soundtest "+tostring(sfx_kc5e))
	io.close(file)
	
	print("Cosmetics config saved.")
end*/

--Searches the database for stuff based on a string, returns the index or nil
local function search(table, tlen, str)
	for i = 1, tlen
		--print(table[i].name.." =?= "..str)
		if table[i].name == str
			--print("match")
			return i
		end
	end
end

--Console commands used by the config file. Can also be used manually of course
COM_AddCommand("hat", function(player, hat)
	local s = search(Cosmetics.Hats, #Cosmetics.Hats, hat)
	if (s)
		hat = s
	else
		hat = tonumber(hat)
	end
	if hat == nil or hat < 0 or hat > #Cosmetics.Hats
		if player == consoleplayer
			print("Invalid hat ID")
		end
		return
	end
	player.cos_hat = hat
end)
COM_AddCommand("hatcolor", function(player, hatcolor)
	local s = search(skincolors, #skincolors - 1, hatcolor)
	if (s)
		hatcolor = s
	else
		hatcolor = tonumber(hatcolor)
	end
	if hatcolor == nil or hatcolor < 0 or hatcolor > #skincolors - 1
		if player == consoleplayer
			print("Invalid hatcolor ID")
		end
		return
	end
	player.cos_hatcolor = hatcolor
end)
COM_AddCommand("deathsound", function(player, deathsound)
	local s = search(Cosmetics.Deathsounds, #Cosmetics.Deathsounds, deathsound)
	if (s)
		deathsound = s
	else
		deathsound = tonumber(deathsound)
	end
	if deathsound == nil or deathsound < 0 or deathsound > #Cosmetics.Deathsounds
		if player == consoleplayer
			print("Invalid deathsound ID")
		end
		return
	end
	player.cos_deathsound = deathsound
end)
COM_AddCommand("hitsound", function(player, hitsound)
	local s = search(Cosmetics.Hitsounds, #Cosmetics.Hitsounds, hitsound)
	if (s)
		hitsound = s
	else
		hitsound = tonumber(hitsound)
	end
	if hitsound == nil or hitsound < 0 or hitsound > #Cosmetics.Hitsounds
		if player == consoleplayer
			print("Invalid hitsound ID")
		end
		return
	end
	player.cos_hitsound = hitsound
end)
COM_AddCommand("chatsound", function(player, chatsound)
	local s = search(Cosmetics.Chatsounds, #Cosmetics.Chatsounds, chatsound)
	if (s)
		chatsound = s
	else
		chatsound = tonumber(chatsound)
	end
	if chatsound == nil or chatsound < 0 or chatsound > #Cosmetics.Chatsounds
		if player == consoleplayer
			print("Invalid chatsound ID")
		end
		return
	end
	player.cos_chatsound = chatsound
end)

--Toggle the menu
local menu_toggle = function(player)
	if player.cos_menu
		player.cos_menu = false
		S_StartSound(nil, sfx_s3k76, player)
		hud.enable("textspectator")
		if player == consoleplayer
			if (player.load_delay == nil or player.load_delay > 0)
				print("Please wait a second and try to save again.")
			//else
				//save(player)
			end
		end
	else
		player.cos_menu = true
		slidevert = 250
		S_StartSound(nil, sfx_s24a, player)
		hud.disable("textspectator")
	end
end

--Console command that opens the cosmetics menu... just in case
COM_AddCommand("cosmetics", function(player)
	if gamestate == GS_INTERMISSION
		return
	end
	menu_toggle(player)
end)

--Lets players rebind the cosmetics menu button
COM_AddCommand("cos_button", function(player, button)
	local validbuttons = "fire, firenormal, tossflag, custom1, custom2, custom3, nextweapon, prevweapon, none"
	if button == nil
		if player == consoleplayer
			print("Valid buttons: "+validbuttons)
		end
		return
	end
	if button == "none"
		player.cos_button = button
		if player == consoleplayer
			print("Disabled cosmetics button")
			//save(player)
		end
	elseif menubuttons[button]
		player.cos_button = button
		if player == consoleplayer
			print("Changed cosmetics button to "+menubuttons[button].name)
			//save(player)
		end
	else
		if player == consoleplayer
			print("Invalid button. Valid buttons: "+validbuttons)
		end
	end
end)

--Reset the hud on map change
local hud_bgfade = 0
local function hud_reset()
	hud_bgfade = 0
	hud.enable("textspectator")
end
addHook("MapLoad", hud_reset)

--Returns true if player is spectating or intermission is happening
local menu_allowed = function(player)
	return (
		player
		and player.cos_init
		and not player.load_delay
		and gamestate == GS_LEVEL
		and (
			player.spectator
			or player.playerstate == PST_DEAD
			or (
				(gametyperules & GTR_FRIENDLY)
				or (gametyperules & GTR_RACE)
			)
		)
	)
end

--Cycle through stuff
local cycle = function(value, dir, max)
	value = $ + dir
	if value < 1
		value = max
	elseif value > max
		value = 1
	end
	return value
end
local cyclezero = function(value, dir, max)
	value = $ + dir
	if value < 0
		value = max
	elseif value > max
		value = 0
	end
	return value
end

--Player input stuff
addHook("PreThinkFrame", function()
	for player in players.iterate
		--Init
		if player.cos_init == nil
			player.cos_init = true
			player.cos_menu_item = 1
			--Settings
			--TODO: Load from file
			player.cos_hat = 0
			player.cos_hatcolor = 0
			player.cos_deathsound = 0
			player.cos_hitsound = 0
			player.cos_chatsound = 0
			player.cos_button = "custom1"
		end
		
		--Load delay. Should load the cosmetics config each time you rejoin the server
		/*if player.load_delay == nil
			player.load_delay = TICRATE
		end
		if player.load_delay
			player.load_delay = $ - 1
			if player.load_delay == 10 and player == consoleplayer
				COM_BufInsertText(consoleplayer, "exec cosmetics.cfg -noerror")
			end
			return
		end*/
		
		--Get buttons
		if player.cos_cmd
			player.cos_prevcmd = player.cos_cmd
		end
		player.cos_cmd = {
			forwardmove = player.cmd.forwardmove,
			sidemove = player.cmd.sidemove,
			buttons = player.cmd.buttons
		}
		local cmd = player.cos_cmd
		local pcmd = player.cos_prevcmd
		
		--Force close menu when it's not usable
		if player.cos_menu and not menu_allowed(player)
			menu_toggle(player)
		end
		
		--Using the menu
		if player.cos_menu
			--Lock buttons
			player.cmd.forwardmove = 0
			player.cmd.sidemove = 0
			player.cmd.buttons = 0
			--player.cmd.angleturn = 0
			--player.cmd.aiming = 0
			
			local up = (cmd.forwardmove > 30)
			local down = (cmd.forwardmove < -30)
			local pup = (pcmd.forwardmove > 30)
			local pdown = (pcmd.forwardmove < -30)
			up = (up and not pup)
			down = (down and not pdown)
			
			local left = (cmd.sidemove < -30)
			local right = (cmd.sidemove > 30)
			local pleft = (pcmd.sidemove < -30)
			local pright = (pcmd.sidemove > 30)
			left = (left and not pleft)
			right = (right and not pright)
			
			if (player.cos_battlefix)
				left = false
				right = false
				up = false
				down = false
				player.cos_battlefix = nil
			end
			
			if (up)
				player.cos_menu_item = cycle($, -1, #menuitems)
				S_StartSound(nil, sfx_s3k89, player)
			elseif (down)
				player.cos_menu_item = cycle($, 1, #menuitems)
				S_StartSound(nil, sfx_s3k89, player)
			end
			
			local cy = 0
			if (left)
				cy = -1
			elseif (right)
				cy = 1
			end
			
			local menu = player.cos_menu_item
			if cy != 0
				slide = 4 * cy
				if menu == 1--Hat
					player.cos_hat = cyclezero($, cy, #Cosmetics.Hats)
					
				elseif menu == 2--Hat col
					while (true)
						player.cos_hatcolor = cyclezero($, cy, #skincolors - 1)
						if player.cos_hatcolor == 0 or skincolors[player.cos_hatcolor].accessible
							break
						end
					end
					
				elseif menu == 3--Deathsound
					player.cos_deathsound = cyclezero($, cy, #Cosmetics.Deathsounds)
					if player.cos_deathsound
						S_StartSound(nil, Cosmetics.Deathsounds[player.cos_deathsound].sound, player)
					end
					
				elseif menu == 4--Hitsound
					player.cos_hitsound = cyclezero($, cy, #Cosmetics.Hitsounds)
					if player.cos_hitsound
						S_StartSound(nil, Cosmetics.Hitsounds[player.cos_hitsound].sound, player)
					end
					
				elseif menu == 5--Chatsound
					player.cos_chatsound = cyclezero($, cy, #Cosmetics.Chatsounds)
					if player.cos_chatsound
						S_StartSound(nil, Cosmetics.Chatsounds[player.cos_chatsound].sound, player)
					else
						S_StartSound(nil, sfx_radio, player)
					end
				end
				
				if menu < 3
					S_StartSound(nil, sfx_s1c7, player)
				end
			end
		end
		
		--Open or close the menu
		if menu_allowed(player) and (cmd.buttons & menubuttons[player.cos_button].btn) and not (pcmd.buttons & menubuttons[player.cos_button].btn)
			menu_toggle(player)
		end
	end
end)

--Draw the menu
local function hud_menu(v, player)
	player = consoleplayer
	if not (player and menu_allowed(player)) return end
	
	--Handle fade
	if player.cos_menu
		hud_bgfade = min($ + 1, 15)
		slidevert = $ * 4/5
	else
		slidevert = 0
		hud_bgfade = max($ - 1, 0)
	end
	v.fadeScreen(0xFF00, hud_bgfade)
	
	--The menu is open! draw stuff
	local xx = 160 + slide
	if slide > 0
		slide = $ - 2
	elseif slide < 0
		slide = $ + 2
	end
	
	if player.cos_menu
		local yy = 22
		
		--Draw current highlighted option info
		local menu = player.cos_menu_item
		
		local hat_id = player.cos_hat
		local charpatch = v.getSprite2Patch(player.skin, SPR2_STND, 0, 2)
		local charheight = skins[player.skin].height / FRACUNIT
		local hat
		local hatpatch
		local hattext = "\134None"
		if hat_id
			hat = Cosmetics.Hats[hat_id]
			hatpatch = v.cachePatch(hat.hudsprite)
			hattext = "\130"+hat.name+" \134by "+hat.artist
		end
		
		--Get colors
		local col = player.skincolor
		local hatcol = skincolors[col].invcolor
		if (player.cos_hatcolor)
			hatcol = player.cos_hatcolor
		end
		
		--Draw the current selection
		v.drawString(160, yy - slidevert, "\134"+menuitems[menu]+":", V_ALLOWLOWERCASE, "thin-center")
		yy = $ + 7
		local text = "\134None"
		if menu == 1
			if hat_id
				text = hattext
			end
		elseif menu == 2
			text = "\136Compliment"
			if leveltime % 16 > 5
				text = "\138Compliment"
			end
			if player.cos_hatcolor
				text = skincolors[hatcol].name
			end
		elseif menu == 3
			if player.cos_deathsound
				text = Cosmetics.Deathsounds[player.cos_deathsound].name
			end
		elseif menu == 4
			if player.cos_hitsound
				text = Cosmetics.Hitsounds[player.cos_hitsound].name
			end
			v.drawString(160, yy - slidevert, text, V_ALLOWLOWERCASE, "center")
		elseif menu == 5
			text = "\134Default"
			if player.cos_chatsound
				text = Cosmetics.Chatsounds[player.cos_chatsound].name
			end
		end
		v.drawString(160, yy - slidevert, text, V_ALLOWLOWERCASE, "center")
		
		--Draw the player & hat
		yy = $ + 92
		v.draw(160, yy - slidevert, charpatch, 0, v.getColormap(player.skin, col))
		if hat_id
			local xxx
			if hat.ismask
				xxx = -3
			else
				xxx = 1
			end
			local skinoffset = Cosmetics.SkinOffsets[skins[player.skin].name] or 0
			v.draw(160 + xxx, yy - slidevert - charheight - skinoffset, hatpatch, 0, v.getColormap(TC_DEFAULT, hatcol))
		end
		
		--Draw menu items
		yy = $ + 10 + slidevert
		for i = 1, #menuitems
			local str = menuitems[i]
			if player.cos_menu_item == i
				if leveltime%20 < 10
					str = "<  \130"+$+"\128  >"
				else
					str = "< \135"+$+"\128 >"
				end
			end
			v.drawString(xx, yy, str, V_ALLOWLOWERCASE, "center")
			yy = $ + 9
		end
		yy = $ + 3
		v.drawString(160, yy, "\130"+menubuttons[player.cos_button].name+": \142Close Menu", 0, "thin-center")
		
	--Prompt to open the menu
	else
		local yyy = 185
		local xxx = 160
		local flags = V_SNAPTOBOTTOM
		local font = "thin-center"
		if leveltime < 15*TICRATE and menu_allowed(player)
			if (leveltime < 15*TICRATE)
				v.drawString(xxx, yyy, "\130"+menubuttons[player.cos_button].name+": \142Customize", V_HUDTRANS | flags, font)
				v.drawString(xxx, yyy + 8, "Console: \139cos_button \128to rebind", V_HUDTRANS | flags, font)
			end
		end
	end
end
hud.add(hud_menu, "game")