freeslot("MT_HAT")
mobjinfo[MT_HAT] = {
	dispoffset = 1,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
}

--Spawn the hat and attach it to a player mobj
addHook("PlayerThink", function(player)
	if not (player.mo and player.mo.valid)
		return
	end
	if (player.cos_hat == 0 and player.mo.hatmobj)
		P_KillMobj(player.mo.hatmobj)
		player.mo.hatmobj = nil
		return
	end
	
	local hm = player.mo.hatmobj
	if not ((player.cos_hat and not player.mo.hatmobj) or (player.cos_hat and (hm and hm.valid and hm.hatid != player.cos_hat)))
		return
	end
	
	local mo = player.mo
	local hat_id = player.cos_hat
	if hat_id > #Cosmetics.Hats
		print("ERROR: Invalid hat ID, out of range")
		return
	end
	
	local data = Cosmetics.Hats[hat_id]
	local hm = P_SpawnMobj(mo.x,mo.y,mo.z,MT_HAT)
	mo.hatmobj = hm
	hm.target = mo
	hm.state = data.state
	hm.hatid = hat_id
	return hm
end, MT_PLAYER)

--Workaround to get the consoleplayer's camera mobj... ugh
local consoleplayer_camera = nil
local function getcam(v, player, camera)
    consoleplayer_camera = camera
end
hud.add(getcam, "game")

--Hat thinker, follow the player and set color / angle / flip
addHook("MobjThinker", function(mo)
	local target = mo.target
	if not (target and target.valid and target.player and target.hatmobj == mo)
		P_KillMobj(mo)
		return
	end
	
	local player = target.player
	local height = target.height
	local data = Cosmetics.Hats[mo.hatid]
	
	--Decide to draw the hat or not
	if (target.flags2 & MF2_DONTDRAW)
	or (target.espio_battleopacity != nil)--shit
	or (target.flags & MF_NOCLIPTHING)
	or (consoleplayer_camera == nil)
	or (consoleplayer_camera.chase == false)
		mo.flags2 = $ | MF2_DONTDRAW
	else
		mo.flags2 = $ & ~MF2_DONTDRAW
	end
	
	--Gravity flip stuff
	if target.eflags & MFE_VERTICALFLIP
		height = 0
		mo.eflags = $|MFE_VERTICALFLIP
		mo.flags2 = $|MF2_OBJECTFLIP
	else
		mo.eflags = $ & ~MFE_VERTICALFLIP
		mo.flags2 = $ & ~MF2_OBJECTFLIP
	end
	
	--Track the player
	mo.scale = target.scale
	mo.destscale = target.destscale
	mo.angle = player.drawangle
	local color = player.cos_hatcolor
	if (color)
		mo.color = color
	else
		mo.color = skincolors[target.color].invcolor--TODO: let people customize this
	end
	local skinoffset = Cosmetics.SkinOffsets[skins[player.skin].name] or 0
	if not data.ismask
		--Standard hat
		P_MoveOrigin(mo,target.x,target.y,target.z + height + skinoffset*FRACUNIT)
	else
		--Masks should be offset a bit...
		local _x = cos(mo.angle) * 4
		local _y = sin(mo.angle) * 4
		P_MoveOrigin(mo,target.x + _x,target.y + _y,target.z + height + skinoffset*FRACUNIT)
	end
	
	--Run hat thinker
	if data.thinker
		data.thinker(mo)
	end
end, MT_HAT)